Player = {}

function Player:load()
    Player.Image = love.graphics.newImage("assets/Player/Player.png")
    Player.xpos = Width_Half
    Player.ypos = Height_Half
    Player.Size = times64(1)
    Player.Width = Player.Size
    Player.Height = Player.Size
    Player.gravity = true
    Player.Alive = true
    Player.Speed = 400
    seconds = 0
    Player.isJumping = false
    Player.jumpSpeed = 450
    Player.jumpTime = 0.5
    Player.hasJumped = false
end

function Player:update(dt)
    seconds = seconds + dt
    Player:checkBounderies()
    if Player.gravity then
        Player.ypos = Player.ypos + gravity * dt
    end
    Player:checkBounderies()
    if checkCollision(Player.xpos, Player.ypos, Player.Width, Player.Height, Floor.xpos, Floor.ypos, Floor.Width, Floor.Height) and Player.gravity and Level == 1 then
        Player.ypos = Floor.ypos - Player.Height
        Player.gravity = false
        Player.hasJumped = false
    end
    Player:checkBounderies()
    if love.keyboard.isDown("w") or love.keyboard.isDown("up") or love.keyboard.isDown("space") then
        if Player.Alive and Player.hasJumped == false then
            if Player.gravity == false then
                Player:jump()
            end
        end
    end
    Player:checkBounderies()
    if love.keyboard.isDown("d") or love.keyboard.isDown("right") then
        Player:MoveRight(dt)
    elseif love.keyboard.isDown("a") or love.keyboard.isDown("left") then
        Player:MoveLeft(dt)
    end
    Player:checkBounderies()
    if Player.isJumping then
        if seconds < Player.jumpTime then
            Player.ypos = Player.ypos - Player.jumpSpeed * dt
        end
        if seconds > Player.jumpTime then
            Player.gravity = true
        end
    end
    if Player:onPlatform() then
        Player.gravity = false
        Player.isJumping = false
        Player.hasJumped = false
    elseif Player:onPlatform() == false and Player.isJumping == false and Player.hasJumped == false then
        Player.gravity = true
    end
    Player:onPlatformbottom()
    Player:onPlatformleft()
    Player:onPlatformright()
end

function Player:draw()
    love.graphics.draw(Player.Image, Player.xpos, Player.ypos)
end

function Player:checkBounderies()
    if Player.xpos < 0 then
        Player.xpos = 0
    end
    if Player.xpos > Window_Width - Player.Size then
        Player.xpos = Window_Width - Player.Size
    end
    if Player.ypos < 0 then
        NextLevel()
    end
    if Player.ypos + Player.Height > Window_Height then
        PreviousLevel()
    end
end

function Player:jump()
    Player.isJumping = true
    Player.hasJumped = true
    seconds = 0
end

function Player:MoveLeft(dt)
    Player.xpos = Player.xpos - Player.Speed * dt
end

function Player:MoveRight(dt)
    Player.xpos = Player.xpos + Player.Speed * dt
end

function Player:onPlatform()
    if checkCollision(Player.xpos, Player.ypos, Player.Width, Player.Height, Platform_1.topx, Platform_1.topy, Platform_1.topWidth, Platform_1.topHeight) then
        Player.ypos = Platform_1.ypos - Player.Height
        return true
    elseif Thicc:toptwo() then
        Player.ypos = Platform_2.ypos - Player.Height
        return true
    elseif Thicc:topthree() then
        Player.ypos = Platform_3.ypos - Player.Height
        return true
    else
        return false
    end
end
function Player:onPlatformleft()
    if checkCollision(Player.xpos, Player.ypos, Player.Width, Player.Height, Platform_1.leftx, Platform_1.lefty, Platform_1.leftWidth, Platform_1.leftHeight) then
        Player.xpos = Platform_1.xpos - Player.Width
        return true
    elseif Thicc:lefttwo() then
        Player.xpos = Platform_2.xpos - Player.Width
        return true
    elseif Thicc:leftthree() then
        Player.xpos = Platform_3.xpos - Player.Width
        return true
    else
        return false
    end
end

function Player:onPlatformbottom()
    if checkCollision(Player.xpos, Player.ypos, Player.Width, Player.Height, Platform_1.bottomx, Platform_1.bottomy, Platform_1.bottomWidth, Platform_1.bottomHeight) then
        if Player.xpos < Platform_1.rightx + Platform_1.rightWidth and Player.xpos + Player.Width > Platform_1.leftx then
            Player.ypos = Platform_1.ypos + Player.Height
            Player.isJumping = false
            Player.hasJumped = false
            Player.gravity = true
            return true
        else
            return false
        end
    elseif Thicc:bottomtwo() then
        if Player.xpos < Platform_2.rightx + Platform_2.rightWidth and Player.xpos + Player.Width > Platform_2.leftx then
            Player.ypos = Platform_2.ypos + Player.Height
            Player.isJumping = false
            Player.hasJumped = false
            Player.gravity = true
            return true
        else
            return false
        end
    elseif Thicc:bottomthree() then
        if Player.xpos < Platform_3.rightx + Platform_3.rightWidth and Player.xpos + Player.Width > Platform_3.leftx then
            Player.ypos = Platform_3.ypos + Player.Height
            Player.isJumping = false
            Player.hasJumped = false
            Player.gravity = true
            return true
        else
            return false
        end
    else
        return false
    end
end

function Player:onPlatformright()
    if checkCollision(Player.xpos, Player.ypos, Player.Width, Player.Height, Platform_1.rightx, Platform_1.righty, Platform_1.rightWidth, Platform_1.rightHeight) then
        Player.xpos = Platform_1.xpos + Platform_1.Width
        return true
    elseif Thicc:righttwo() then
        Player.xpos = Platform_2.xpos + Platform_2.Width
        return true
    elseif Thicc:rightthree() then
        Player.xpos = Platform_3.xpos + Platform_2.Width
        return true
    else
        return false
    end
end